/*
** HDL4SE: 软件Verilog综合仿真平台
** Copyright (C) 2021-2021, raoxianhong<raoxianhong@163.net>
** LCOM: 轻量级组件对象模型
** Copyright (C) 2021-2021, raoxianhong<raoxianhong@163.net>
** All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are met:
**
** * Redistributions of source code must retain the above copyright notice,
**   this list of conditions and the following disclaimer.
** * Redistributions in binary form must reproduce the above copyright notice,
**   this list of conditions and the following disclaimer in the documentation
**   and/or other materials provided with the distribution.
** * The name of the author may be used to endorse or promote products
**   derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
** AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
** IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
** ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
** LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
** THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
* hdl4se_unop.c
  修改记录：
	202105230816: rxh, initial version
	202105241522：rxh, 增加Detector接口
*/
#include "stdlib.h" 
#include "stdio.h"
#include "string.h"
#include "object.h"
#include "dlist.h"
#include "bignumber.h"
#include "hdl4secell.h"

/*
#define UNOP_NEG 0
#define UNOP_NOT 1
#define UNOP_AND 2
#define UNOP_OR  3
#define UNOP_XOR 4
*/
#define UNOP_LAST UNOP_XOR
/* 
HDL4SE_UNOP
instance parameter: "8, 1, 2", 
inputwidth=8, outputwidth=1, unop=UNOP_AND 
*/
typedef struct _sHDL4SEUnop {
	OBJECT_HEADER
	INTERFACE_DECLARE(IHDL4SEUnit)
	HDL4SEUNIT_VARDECLARE
	INTERFACE_DECLARE(IHDL4SEDetector)
	HDL4SEDETECTOR_VARDECLARE
	DLIST_VARDECLARE
	
	IHDL4SEModule** parent;
	char* name;

	IHDL4SEUnit** wire_in;
	int wire_in_index;
	int in_width;

	IBigNumber** in_data;
	IBigNumber** out_data;
	int out_width;
	int op;
	int datavalid;
}sHDL4SEUnop;

OBJECT_FUNCDECLARE(hdl4se_unop, CLSID_HDL4SE_UNOP);
HDL4SEUNIT_FUNCDECLARE(hdl4se_unop, CLSID_HDL4SE_UNOP, sHDL4SEUnop);
HDL4SEDETECTOR_FUNCDECLARE(hdl4se_unop, CLSID_HDL4SE_UNOP, sHDL4SEUnop);
DLIST_FUNCIMPL(hdl4se_unop, CLSID_HDL4SE_UNOP, sHDL4SEUnop);

OBJECT_FUNCIMPL(hdl4se_unop, sHDL4SEUnop, CLSID_HDL4SE_UNOP);


QUERYINTERFACE_BEGIN(hdl4se_unop, CLSID_HDL4SE_UNOP)
QUERYINTERFACE_ITEM(IID_HDL4SEUNIT, IHDL4SEUnit, sHDL4SEUnop)
QUERYINTERFACE_ITEM(IID_HDL4SEDETECTOR, IHDL4SEDetector, sHDL4SEUnop)
QUERYINTERFACE_ITEM(IID_DLIST, IDList, sHDL4SEUnop)
QUERYINTERFACE_END

static const char* hdl4se_unopModuleInfo()
{
	return "1.0.0-20210523.0816 HDL4SE UNOP cell";
}

static int hdl4se_unopCreate(const PARAMITEM* pParams, int paramcount, HOBJECT* pObject)
{
	sHDL4SEUnop* pobj;
	int i;
	pobj = (sHDL4SEUnop*)malloc(sizeof(sHDL4SEUnop));
	if (pobj == NULL)
		return -1;
	*pObject = 0;
	HDL4SEUNIT_VARINIT(pobj, CLSID_HDL4SE_UNOP);
	INTERFACE_INIT(IHDL4SEUnit, pobj, hdl4se_unop, hdl4se_unit);
	INTERFACE_INIT(IHDL4SEDetector, pobj, hdl4se_unop, hdl4se_detector);
	DLIST_VARINIT(pobj, hdl4se_unop);

	pobj->wire_in = NULL;
	pobj->wire_in_index = 0;
	pobj->out_data = NULL;
	pobj->in_data = NULL;

	pobj->name = NULL;
	pobj->in_width = 0;
	pobj->out_width = 0;
	pobj->datavalid = 0;
	pobj->op = -1;
	pobj->parent = NULL;

	for (i = 0; i < paramcount; i++) {
		if (pParams[i].name == PARAMID_HDL4SE_UNIT_NAME) {
			if (pobj->name != NULL)
				free(pobj->name);
			pobj->name = strdup(pParams[i].pvalue);
		} 
		else if (pParams[i].name == PARAMID_HDL4SE_UNIT_PARENT) {
			pobj->parent = (IHDL4SEModule **)pParams[i].pvalue;
		}
		else if (pParams[i].name == PARAMID_HDL4SE_UNIT_INSTANCE_PARAMETERS) {
			IBigNumber** temp = bigintegerCreate(32);
			if (temp != NULL) {
				const char* nstr;
				const char* lstr;
				lstr = (const char*)pParams[i].pvalue;
				if (0 == objectCall3(temp, AssignStr, lstr, &nstr, 0)) {
					objectCall1(temp, GetInt32, &pobj->in_width);
				}
				else {
					return EIID_INVALIDPARAM;
				}
				lstr = nstr;
				if (0 == objectCall3(temp, AssignStr, lstr, &nstr, 0)) {
					objectCall1(temp, GetInt32, &pobj->out_width);
				}
				else {
					return EIID_INVALIDPARAM;
				}
				lstr = nstr;
				if (0 == objectCall3(temp, AssignStr, lstr, &nstr, 0)) {
					objectCall1(temp, GetInt32, &pobj->op);
				}
				else {
					return EIID_INVALIDPARAM;
				}
				lstr = nstr;
				objectRelease(temp);
			}
		}
	}

	if (pobj->in_width <= 0)
		return EIID_INVALIDPARAM;
	if (pobj->out_width <= 0)
		return EIID_INVALIDPARAM;
	if (pobj->op < UNOP_NEG || pobj->op > UNOP_LAST)
		return EIID_INVALIDPARAM;

	pobj->out_data = bigintegerCreate(pobj->out_width);
	pobj->in_data = bigintegerCreate(pobj->in_width);

	/* 返回生成的对象 */
	OBJECT_RETURN_GEN(hdl4se_unop, pobj, pObject, CLSID_HDL4SE_UNOP);
	return EIID_OK;
}

static void hdl4se_unopDestroy(HOBJECT object)
{
	sHDL4SEUnop* pobj;
	pobj = (sHDL4SEUnop*)objectThis(object);
	if (pobj->name != NULL)
		free(pobj->name);
	objectRelease(pobj->wire_in);
	objectRelease(pobj->out_data);
	objectRelease(pobj->in_data);
	memset(pobj, 0, sizeof(sHDL4SEUnop));
	free(pobj);
}

static int hdl4se_unopValid(HOBJECT object)
{
	sHDL4SEUnop* pobj;
	pobj = (sHDL4SEUnop*)objectThis(object);
	return 1;
}

static int hdl4se_unop_hdl4se_unit_Connect(HOBJECT object, int index, HOBJECT from, int fromindex) 
{
	sHDL4SEUnop* pobj;
	IHDL4SEUnit** unit = NULL;
	pobj = (sHDL4SEUnop*)objectThis(object);
	if (0 == objectQueryInterface(from, IID_HDL4SEUNIT, (void**)&unit)) {
		objectRelease(pobj->wire_in);
		pobj->wire_in = unit;
		pobj->wire_in_index = fromindex;
		return 0;
	}
	return -1;
}

static int hdl4se_unop_hdl4se_unit_GetValue(HOBJECT object, int index, int width, IBigNumber ** value)
{
	sHDL4SEUnop* pobj;
	pobj = (sHDL4SEUnop*)objectThis(object);
	if (pobj->datavalid == 0) {
		switch (pobj->op) {
		case UNOP_NEG: 
			objectCall3(pobj->wire_in, GetValue, pobj->wire_in_index, pobj->in_width, pobj->out_data);
			objectCall1(pobj->out_data, Neg, pobj->out_data);
		break;
		case UNOP_NOT: 
			objectCall3(pobj->wire_in, GetValue, pobj->wire_in_index, pobj->in_width, pobj->out_data);
			objectCall1(pobj->out_data, Not, pobj->out_data);
			break;
		case UNOP_AND:
			objectCall3(pobj->wire_in, GetValue, pobj->wire_in_index, pobj->in_width, pobj->in_data);
			objectCall1(pobj->out_data, AssignInt32, 0);
			if (objectCall1(pobj->out_data, uAnd, pobj->out_data) != 0) {
				objectCall1(pobj->out_data, AssignInt32, 1);
			}
			break;
		case UNOP_OR:
			objectCall3(pobj->wire_in, GetValue, pobj->wire_in_index, pobj->in_width, pobj->in_data);
			objectCall1(pobj->out_data, AssignInt32, 0);
			if (objectCall1(pobj->out_data, uOr, pobj->out_data) != 0) {
				objectCall1(pobj->out_data, AssignInt32, 1);
			}
			break;
		case UNOP_XOR:
			objectCall3(pobj->wire_in, GetValue, pobj->wire_in_index, pobj->in_width, pobj->in_data);
			objectCall1(pobj->out_data, AssignInt32, 0);
			if (objectCall1(pobj->out_data, uXor, pobj->out_data) != 0) {
				objectCall1(pobj->out_data, AssignInt32, 1);
			}
			break;
		}
		pobj->datavalid = 1;
		objectCall2(pobj->out_data, SetWidth, pobj->out_width, 1);
	}
	objectCall1(value, Assign, pobj->out_data);
	return 0;
}

static int hdl4se_unop_hdl4se_unit_ClkTick(HOBJECT object)
{
	sHDL4SEUnop* pobj;
	pobj = (sHDL4SEUnop*)objectThis(object);
	return 0;
}

static int hdl4se_unop_hdl4se_unit_Setup(HOBJECT object)
{
	sHDL4SEUnop* pobj;
	pobj = (sHDL4SEUnop*)objectThis(object);
	pobj->datavalid = 0;
	return 0;
}

static int hdl4se_unop_hdl4se_detector_GetName(HOBJECT object, const char** pname)
{
	sHDL4SEUnop* pobj;
	pobj = (sHDL4SEUnop*)objectThis(object);
	*pname = pobj->name;
	return 0;
}

static int hdl4se_unop_hdl4se_detector_GetSignalCount(HOBJECT object)
{
	sHDL4SEUnop* pobj;
	pobj = (sHDL4SEUnop*)objectThis(object);
	return 2;
}

static int hdl4se_unop_hdl4se_detector_GetSignalInfo(HOBJECT object, int index, const char** pname, int *width)
{
	sHDL4SEUnop* pobj;
	pobj = (sHDL4SEUnop*)objectThis(object);
	if (index == 0) {
		*pname = "in";
		*width = pobj->in_width;
	} 
	else if (index == 1) {
		*pname = "out";
		*width = pobj->out_width;
	}
	return 0;
}

static int hdl4se_unop_hdl4se_detector_GetSignalValue(HOBJECT object, int index, IBigNumber** value)
{
	sHDL4SEUnop* pobj;
	pobj = (sHDL4SEUnop*)objectThis(object);
	if (index == 0)
		objectCall3(pobj->wire_in, GetValue, pobj->wire_in_index, pobj->in_width, value);
	else if (index == 1)
		return hdl4se_unop_hdl4se_unit_GetValue(object, index, pobj->out_width, value);
	return 0;
}

static int hdl4se_unop_hdl4se_detector_GetUnitCount(HOBJECT object)
{
	sHDL4SEUnop* pobj;
	pobj = (sHDL4SEUnop*)objectThis(object);
	return 0;
}

static int hdl4se_unop_hdl4se_detector_GetUnit(HOBJECT object, int index, HOBJECT* unit)
{
	sHDL4SEUnop* pobj;
	pobj = (sHDL4SEUnop*)objectThis(object);
	return 0;
}

